import java.util.*;
import tester.*;

/** Represents an abstract binary search tree */
public abstract class ABST<T> implements Traversal<T>{
    /** Comparator that determines the data ordering */
    protected Comparator<T> comp;
    
    public ABST(Comparator<T> comp){
        this.comp = comp;
    }
    
    /** Make the return of getRest() from Traversal more specific
     *   (to eliminate casting) */
    public abstract ABST<T> getRest();

    /** Count the number of Nodes in this BST */
    public abstract int countNodes();

    /** Insert the given T into this binary search tree */
    public abstract ABST<T> insert(T d);

    /** Accept a Visitor for this binary search tree.  Calls the
     *   Visitor's appropriate method to allow it to compute a result.
     *   Parametrized by the Visitor's return type. */
    public abstract <R> R accept(ABSTVisitor<T, R> vis);
}