import java.util.*;
import tester.*;

/** Represents Examples and Tests for BSTs/Traversals/Visitors */
public class Examples{
    Examples(){}
    
    Book oms  = new Book("Old Man and the Sea", "Hemingway", 65);
    Book eos  = new Book("Elements of Style", "EBW", 15);
    Book htdp = new Book("HtDP", "MF", 60);
    Book ll   = new Book("Little Lisper", "MF", 20); 

    Comparator<Book> booksByPrice = new BookByPrice();

    ABST<Book> leaf = new Leaf<Book>(booksByPrice);
    ABST<Book> tree3 = new Node<Book>(htdp, 
                                      new Node<Book>(this.eos, this.leaf, this.leaf),
                                      new Node<Book>(this.oms, this.leaf, this.leaf));
    ABST<Book> tree4 = tree3.insert(ll);
  
    /** Test the countNodes method in the ABST classes  */
    void testCountABST(Tester t){
        t.checkExpect(this.leaf.countNodes(), 0);
        t.checkExpect(this.tree3.countNodes(), 3);
        t.checkExpect(this.tree4.countNodes(), 4);
    }
  
    Algorithms algos = new Algorithms();
 
    /** Test the countNodes method in the Algorithms class  */
    void testCountAlgorithms(Tester t){
        t.checkExpect(algos.countNodes(leaf), 0);
        t.checkExpect(algos.countNodes(tree3), 3);
        t.checkExpect(algos.countNodes(tree4), 4);
    }    
  
    ABSTVisitor<Book, Integer> countNodes = new CountNodes<Book>();

    /** Test the Visitor based countNodes implementation  */
    void testCountVisitor(Tester t){
        t.checkExpect(leaf.accept(countNodes), 0);
        t.checkExpect(tree3.accept(countNodes), 3);
        t.checkExpect(tree4.accept(countNodes), 4);
    }
}
