import java.util.*;
import tester.*;

/** Represents the Leaf of a binary search tree */
public class Leaf<T> extends ABST<T>{

    Leaf(Comparator<T> comp){
        super(comp);
    }

    /** Is this an empty tree (a Leaf)? */
    public boolean isEmpty(){
        return true;
    }
  
    /** Produce the smallest element in this tree */
    public T getFirst(){
        throw new IllegalUseOfTraversalException("No first element in a leaf");
    }
  
    /** Produce a binary search tree without this Tree's smallest element */
    public ABST<T> getRest(){
        throw new IllegalUseOfTraversalException("No more elements in a leaf");
    } 
  
    /** Count the number of Nodes in this BST */
    public int countNodes(){
        return 0;
    }

    /** Insert the given T into this binary search tree */
    public ABST<T> insert(T d){
        return new Node<T>(d, this, this);
    }

    /** Call the Visitor's Leaf method to allow it to compute a result.
     *    Parametrized by the Visitor's return type */
    public <R> R accept(ABSTVisitor<T, R> vis){
        return vis.visitLeaf();
    }
}

