import java.util.*;
import tester.*;

/** Represents a Node in a binary search tree */
public class Node<T> extends ABST<T>{
    T data;
    ABST<T> left;
    ABST<T> right;

    Node(T data, ABST<T> left, ABST<T> right){
        super(left.comp);
        this.data = data;
        this.left = left;
        this.right = right;
    }
  
    /** Is this an empty tree (a Leaf)? */
    public boolean isEmpty(){
        return false;
    }
  
    /** Produce the smallest element in this tree */
    public T getFirst(){
        // ** Incorrect **
        return this.data;
    }
  
    /** Produce a binary search tree without this Tree's smallest element */
    public ABST<T> getRest(){
        // ** Incorrect **
        return this.left;
    }

    /** Count the number of Nodes in this BST */
    public int countNodes(){
        return 1 + this.left.countNodes() + this.right.countNodes();
    }

    /** Insert the given T into this binary search tree */
    public ABST<T> insert(T d){
        if (comp.compare(d, this.data) <= 0){
            return new Node<T>(this.data, this.left.insert(d), this.right);
        }else{
            return new Node<T>(this.data, this.left, this.right.insert(d));
        }
    }

    /** Call the Visitor's Node method to allow it to compute a result.
     *    Parametrized by the Visitor's return type */
    public <R> R accept(ABSTVisitor<T, R> vis){
        return vis.visitNode(this.data, this.left, this.right);
    }
}
